// LiteLoader-AIDS automatic generated
/// <reference path="c:\bdsplugin/dts/helperlib/src/index.d.ts"/> 


let config = new JsonConfigFile(
    ".\\plugins\\NewPlayerRecord\\data.json",
    JSON.stringify({
        Accumulated_Server_Players_Numbers: 0,
        Daily_Login_Records: {},
        EveryDay_new_players: 0,
        new_player_list: {},
        daily_new_players_list: {},
        player_join_date: {},
        lastCheckDate: null
    }, null, 4)
);

function saveData(data) {
    config.write(JSON.stringify(data, null, 4));
    config.reload();
    //logger.warn("数据已保存");
}

function loadData() {
    let jsonData = config.read();
    let data = JSON.parse(jsonData);
    //logger.warn("加载数据:", data);
    checkAndResetDailyCounts(data);
    return data;
}

function getCurrentDate() {

    //方案一（已弃用）
    /*获取当前日期并按照指定时区处理
    return new Date().toLocaleDateString('en-US', { timeZone: 'Asia/Shanghai' });
    */

    //方案二（已弃用）
    // 使用toISOString并通过分割得到YYYY-MM-DD格式的日期字符串（这个获取到的时间不是最新的，不知道为什么）
    //return new Date().toISOString().split('T')[0];

    //方案三（可行方案）
    // 使用system.getTimeStr()并通过分割得到YYYY-MM-DD格式的日期字符串
    return system.getTimeStr().split(" ")[0];
}

/*
logger.warn(getCurrentDate())
logger.warn(system.getTimeStr().split(" ")[0])
*/

function checkAndResetDailyCounts(data) {
    let today = getCurrentDate();
    //logger.warn("系统日期检查:", new Date().toString());
    //logger.warn("今日日期:", today, "最后检查日期:", data.lastCheckDate);

    if (!data.lastCheckDate || data.lastCheckDate !== today) {
        //logger.warn("检测到日期更改，重置每日新玩家数");
        data.EveryDay_new_players = 0;
        data.daily_new_players_list[today] = []; // 初始化当天的 [新玩家] 名单数组
        data.Daily_Login_Records[today] = []; // 初始化当天的 [进过服的玩家] 名单数组
        data.lastCheckDate = today;
        saveData(data);
    } else {
        //logger.warn("日期未更改，不需要重置");
    }
}

mc.listen("onJoin", (pl) => {
    if (!pl.isSimulatedPlayer()) {
        let data = loadData();
        let playerName = pl.realName;
        let today = getCurrentDate();

        if (!data.new_player_list[playerName]) {
            data.Accumulated_Server_Players_Numbers++;
            data.EveryDay_new_players++;
            data.new_player_list[playerName] = data.Accumulated_Server_Players_Numbers;
            data.player_join_date[playerName] = data.lastCheckDate;

            
            //更新每日新玩家列表
            /*
            if (!data.daily_new_players_list[today]) {
                data.daily_new_players_list[today] = [];
            }
            */
            //添加检查以避免重复
            if (!data.daily_new_players_list[today].includes(playerName)) {
                data.daily_new_players_list[today].push(playerName);
            }

        }

        // 更新每日新玩家列表
        if (!data.Daily_Login_Records[today]) {
            data.Daily_Login_Records[today] = [];
        }
        if (!data.Daily_Login_Records[today].includes(playerName)) {
            data.Daily_Login_Records[today].push(playerName);
        }

        saveData(data);

        let firstJoinDate = new Date(data.player_join_date[playerName]);
        let currentDate = new Date(data.lastCheckDate);
        let daysSinceFirstJoin = Math.floor((currentDate - firstJoinDate) / (1000 * 3600 * 24));

        let msg = `累计进服人数：${data.Accumulated_Server_Players_Numbers}人，今日进服人数：${data.EveryDay_new_players}人，你是第${data.new_player_list[playerName]}个进服的。你第一次进服的日期是：${data.player_join_date[playerName]}。你从第一次进服到现在已经过去了${daysSinceFirstJoin}天。`;
        setTimeout(() => {
            if (pl.realName) {
                pl.tell(msg);
            }
        }, 3000);
    }
});
mc.listen("onServerStarted", () => {
    const query_1 = mc.newCommand(`querydailynewplayerslist`, `§b查询每日§c新进服§b玩家列表`, PermType.Any);
    query_1.setAlias(`qdnpl`);
    query_1.overload();
    query_1.setCallback((cmd, ori, out, res) => {
        out.success(getTodayNewPlayersList());
    })
    query_1.setup();

    const query_2 = mc.newCommand(`querydailyloginplayerslist`, `§e查询每日§d登录游戏§b玩家列表`, PermType.Any);
    query_2.setAlias(`qdlpl`);
    query_2.overload();
    query_2.setCallback((cmd, ori, out, res) => {
        out.success(getDailyLoginRecordPlayersList());
    })
    query_2.setup();

})
function getTodayNewPlayersList() { // 每日 [新进服] 玩家名字列表
    let data = loadData();
    let today = getCurrentDate();
    let todayPlayers = data.daily_new_players_list[today];

    if (!todayPlayers) {
        return "§7今日暂无新玩家进服";
    }

    let playerListString = todayPlayers.join('§b\n§b');
    if (playerListString.length <= 0) {
        return `§7今日暂无新玩家进服`;
    } else {
        return `§b` + playerListString;
    }
}

function getDailyLoginRecordPlayersList() { // 每日 [登录服务器] 玩家名字列表
    let data = loadData();
    let today = getCurrentDate();
    let todayPlayers = data.Daily_Login_Records[today];
    //logger.warn(`todayPlayers : ` + todayPlayers);
    if (!todayPlayers) {
        return "今日暂无玩家登录";
    }

    let playerListString = todayPlayers.join(`§e\n§e`);
    if (playerListString.length <= 0) {
        return `今日暂无玩家登录`;
    } else {
        return `§e` + playerListString;
    }
}

function getDailyLoginRecordPlayersNum() { // 每日 [登录服务器] 玩家数
    let data = loadData();
    let today = getCurrentDate();
    let todayPlayers = data.Daily_Login_Records[today];
    if (todayPlayers.length >= 0) {
        return `${todayPlayers.length}`;
    } else {
        return `今日暂无玩家登录`;
    }
}

//logger.warn(getDailyLoginRecordPlayersList())
/*
logger.warn(getTodayNewPlayersList())
logger.warn(typeof getTodayNewPlayersList())
logger.warn(getTodayNewPlayersList().length)
*/

function getTotalJoinServerPlayerNum() {
    let data = loadData(); // 直接得到已解析的 JSON 对象
    return `${data.Accumulated_Server_Players_Numbers}`; //返回累计进服人数的字符串
}

function getEveryDayNewPlayersNum() {
    let data = loadData(); // 直接得到已解析的 JSON 对象
    return `${data.EveryDay_new_players}`; //返回今日进服人数的字符串
}

// 完善玩家进服日期函数
function getPlayerJoinServerDate(pl) {
    let data = loadData(); // 直接得到已解析的 JSON 对象
    let playerName = pl.realName;
    let joinDate = data.player_join_date[playerName];
    if (joinDate) {
        return joinDate; // 如果有记录，返回玩家的进服日期
    } else {
        return "无记录"; // 如果没有记录，返回"无记录"
    }
}

// 完善玩家是第几个进服的函数
function getPlayerJoinServerOrder(pl) {
    let data = loadData(); // 直接得到已解析的 JSON 对象
    let playerName = pl.realName;
    let order = data.new_player_list[playerName];
    if (order) {
        return `${order}`; // 如果有记录，返回玩家是第几个进服的数字字符串
    } else {
        return "无记录"; // 如果没有记录，返回"无记录"
    }
}

// 完善玩家进服日期距离现在多少天的函数
function getPlayerDaysSinceFirstJoin(pl) {
    let data = loadData(); // 直接得到已解析的 JSON 对象
    let playerName = pl.realName;
    let joinDateStr = data.player_join_date[playerName];
    if (joinDateStr) {
        let joinDate = new Date(joinDateStr);
        let currentDate = new Date();
        let daysSinceFirstJoin = Math.floor((currentDate - joinDate) / (1000 * 3600 * 24)); // 计算距离第一次进服的天数
        return `${daysSinceFirstJoin}`;
    } else {
        return "无记录"; // 如果没有记录，返回"无记录"
    }
}

//通过玩家名获取玩家进服数据
// 完善玩家进服日期函数
function getPlJoinServerDateByName(playerName) {
    let data = loadData(); // 直接得到已解析的 JSON 对象
    let joinDate = data.player_join_date[playerName];
    if (joinDate) {
        return joinDate; // 如果有记录，返回玩家的进服日期
    } else {
        return "无记录"; // 如果没有记录，返回"无记录"
    }
}

// 完善玩家是第几个进服的函数
function getPlJoinServerOrderByName(playerName) {
    let data = loadData(); // 直接得到已解析的 JSON 对象
    let order = data.new_player_list[playerName];
    if (order) {
        return `${order}`; // 如果有记录，返回玩家是第几个进服的数字字符串
    } else {
        return "无记录"; // 如果没有记录，返回"无记录"
    }
}

// 完善玩家进服日期距离现在多少天的函数
function getPlDaysSinceFirstJoinByName(playerName) {
    let data = loadData(); // 直接得到已解析的 JSON 对象
    let joinDateStr = data.player_join_date[playerName];
    if (joinDateStr) {
        let joinDate = new Date(joinDateStr);
        let currentDate = new Date();
        let daysSinceFirstJoin = Math.floor((currentDate - joinDate) / (1000 * 3600 * 24)); // 计算距离第一次进服的天数
        return `${daysSinceFirstJoin}`;
    } else {
        return "无记录"; // 如果没有记录，返回"无记录"
    }
}

//通过玩家对象获取玩家进服数据
ll.exports(getPlayerJoinServerDate, `NewPlayerRecord`, `getPlayerJoinServerDate`); // 导出获取玩家进服日期API
ll.exports(getPlayerJoinServerOrder, `NewPlayerRecord`, `getPlayerJoinServerOrder`); // 导出获取玩家进服顺序API
ll.exports(getPlayerDaysSinceFirstJoin, `NewPlayerRecord`, `getPlayerDaysSinceFirstJoin`); // 导出获取玩家进服时长天数API

//通过玩家名获取玩家进服数据
ll.exports(getPlJoinServerDateByName, `NewPlayerRecord`, `getPlJoinServerDateByName`); // 导出获取玩家进服日期API
ll.exports(getPlJoinServerOrderByName, `NewPlayerRecord`, `getPlJoinServerOrderByName`); // 导出获取玩家进服顺序API
ll.exports(getPlDaysSinceFirstJoinByName, `NewPlayerRecord`, `getPlDaysSinceFirstJoinByName`); // 导出获取玩家进服时长天数API

mc.listen("onServerStarted", () => {
    if (File.exists("./plugins/GMLIB-LegacyRemoteCallApi/lib/BEPlaceholderAPI-JS.js") && File.exists("./plugins/GMLIB-LegacyRemoteCallApi/GMLIB-LegacyRemoteCallApi.dll")) {
        const PAPI = require('./GMLIB-LegacyRemoteCallApi/lib/BEPlaceholderAPI-JS.js').PAPI;
        logger.info(`[NewPlayerRecord] PAPI变量注册成功!`);
        //注册服务器变量
        PAPI.registerServerPlaceholder(getTotalJoinServerPlayerNum, "NewPlayerRecord", "total_players_num");
        PAPI.registerServerPlaceholder(getEveryDayNewPlayersNum, "NewPlayerRecord", "daily_players_num");
        PAPI.registerServerPlaceholder(getTodayNewPlayersList, "NewPlayerRecord", "daily_players_list"); // 注册 每日新进服玩家列表 PAPI
        PAPI.registerServerPlaceholder(getDailyLoginRecordPlayersList, "NewPlayerRecord", "daily_login_players_list"); // 注册 每日登录服务器玩家列表 PAPI
        PAPI.registerServerPlaceholder(getDailyLoginRecordPlayersNum, "NewPlayerRecord", "daily_login_players_num"); // 注册 每日登录服务器玩家数 PAPI
        


        //注册玩家变量
        PAPI.registerPlayerPlaceholder(getPlayerJoinServerDate, "NewPlayerRecord", "pl_join_server_date");
        PAPI.registerPlayerPlaceholder(getPlayerJoinServerOrder, "NewPlayerRecord", "pl_join_server_order");
        PAPI.registerPlayerPlaceholder(getPlayerDaysSinceFirstJoin, "NewPlayerRecord", "pl_playdays");
    } else {
        logger.warn(`未检测到BEPlaceholderAPI！变量注册失败，请检查是否成功安装了GMLIB-LegacyRemoteCallApi，注:此插件推荐在 LeviLamina 0.12.3 LegacyScriptEngine 0.7.7 环境下使用`);
        logger.warn(`此警告信息不影响插件的使用(在你不需要在其他插件中使用本插件注册的PAPI的情况下)`);
    }
})
